print 'IMPORTS'

import os
import sys
import hashlib
import tarfile
import urllib2

from contextlib import closing

print 'DEFINITIONS'

pypi = 'http://pypi.python.org'
url = '/packages/source/f/flufl.enum/flufl.enum-3.2.tar.gz'
md5 = '/pypi?:action=show_md5&digest=0ced537df3b7c322ef2d2bd8392401b8'

def get(path, outfile=None):
    filename = (os.path.basename(path) if outfile is None else outfile)
    with open(filename, 'w') as output:
        with closing(urllib2.urlopen(pypi + url)) as input:
            output.write(input.read())


def md5check(filename, checksum):
    md5 = hashlib.md5()
    with open(filename) as input:
        md5.update(input.read())
    return md5.hexdigest() == checksum


filename = os.path.basename(url)
print 'FILENAME:', filename

# Get the package.
get(url)
print 'GOT PACKAGE'
# Get the md5.
#get(md5, 'md5sum')
print 'GOT MD5SUM'
# Check it.
if not md5check(filename, '0ced537df3b7c322ef2d2bd8392401b8'):
    print 'checksum mismatch'
    sys.exit(1)


# XXX check signature.
print 'CHECK SIGNATURE'
pass

# untar.
print 'UNTAR'
with tarfile.open(filename) as input:
    input.extractall()

print 'CHDIR'
directory = '.'.join(filename.split('.')[:-2])
os.chdir(directory)

print 'TOX.INIT'
with open('tox.ini', 'w') as toxini:
    print >> toxini, """\
[tox]
envlist = py26,py27,py32,py33

[testenv]
commands=python setup.py test -vv

[testenv:py32]
# Because of http://bugs.python.org/issue11250 we can't use stock Python 3.2.2.
# For now, use a Python 3.2.2+ build from the hg branch.
basepython=/home/barry/projects/python/py32/bin/python3

[testenv:py33]
# Python 3.3 isn't released yet, so use a local build from the hg branch.
basepython=/home/barry/projects/python/py33/bin/python3
"""    

print 'TOX'
import tox
tox.cmdline()
